#include "creature.h"
#include "enemy.h"
#include "map.h"

int enemy_act(creature *this)
{
    creature_move(this,(rand()%3)-1,(rand()%3)-1);
    return 1;
}

int enemy_act_toPlayer(creature *this)
{
    creature_move(this,this->x!=player.x?(this->x>player.x?-1:1):0,this->y!=player.y?(this->y>player.y?-1:1):0);
    return 1;
}

void enemy_bump(creature *this, creature *other)
{
    creature_attack(this,other);
}

void randEnemy(int x, int y)
{
    if(map[x][y].occupant)
      return;
    creature *t=creature_new();
    if(!t)
      return;
    t->name="Enemy";
    t->act=enemy_act;
    t->bump=enemy_bump;
    t->c=2;
    t->r=100+rand()%150;
    t->g=100+rand()%150;
    t->b=100+rand()%150;
    t->speed=800+rand()%200;
    t->wait=rand()%10000;
    map[x][y].occupant=t;
    t->x=x;
    t->y=y;
    addChange(x,y);
}

creature* genRandEnemy()
{
    int x=rand()%90,y=rand()%40;
    int n=0;
    while(map[x][y].occupant)
    {
        x=rand()%90;
        y=rand()%40;
        n++;
        if(n>100)
          return 0;
    }
    creature *t=creature_new();
    if(!t)
      return;
    t->name="Enemy";
    t->act=enemy_act;
    t->bump=enemy_bump;
    t->c=2;
    t->r=100+rand()%150;
    t->g=100+rand()%150;
    t->b=100+rand()%150;
    t->speed=800+rand()%200;
    t->wait=rand()%10000;
    map[x][y].occupant=t;
    t->x=x;
    t->y=y;
    return t;
}

creature *enemy_leveled(int level)
{
    creature *t=creature_new();
    if(!t)
      return 0;
    t->name="Enemy";
    t->act=enemy_act_toPlayer;
    t->bump=enemy_bump;
    t->c=2;
    t->gold = rand()%(level*5);
    t->arrows = 0;
    if(rand()%3==0)
      t->arrows=rand()%(level*2);
    t->r=100+rand()%150;
    t->g=100+rand()%150;
    t->b=100+rand()%150;
    t->level=rand()%level+1;
    t->speed=800+rand()%200+rand()%(t->level*5);
    t->health+=rand()%(t->level*2);
    t->damage+=rand()%(t->level*5);
    t->damageVar+=rand()%(t->level);
    t->defense+=rand()%(t->level*5);
    t->defenseVar+=rand()%(t->level);
    t->wait=rand()%10000;
    return t;
}

creature* enemy_rand(int probNumerator, int probDenominator, int minLevel, int maxLevel)
{
    if(probDenominator>0 && (rand()%probDenominator)<probNumerator)
    {
        return enemy_leveled(minLevel+(rand()%((maxLevel-minLevel)+1)));
    }
    return 0;
}

void addChaosElemental()
{
    creature *c=genRandEnemy();
    c->name="Chaos Elemental";
    c->speed=1000+rand()%2000;
    c->c='c';
    c->r=rand()%256;
    c->g=rand()%256;
    c->b=rand()%256;
    c->gold = rand()%200;
    c->level = rand()%200;
    c->health = rand()%2000;
    c->maxHealth = rand()%200;
    c->defense = rand()%200;
    c->defenseVar = rand()%200;
    c->damage = rand()%200;
    c->damageVar = rand()%200;
}

void addSuperiorChaosElemental()
{
    creature *c=genRandEnemy();
    c->name="Superior Chaos Elemental";
    c->speed=1000+rand()%5000;
    c->c='C';
    c->r=rand()%256;
    c->g=rand()%256;
    c->b=rand()%256;
    c->gold = rand()%2000;
    c->level = rand()%2000;
    c->health = rand()%20000;
    c->maxHealth = rand()%2000;
    c->defense = rand()%2000;
    c->defenseVar = rand()%2000;
    c->damage = rand()%2000;
    c->damageVar = rand()%2000;
}

