#include <windows.h>
#include "win.h"
#include "creature.h"
#include "logic.h"
#include "map.h"
#include "text.h"
#include "player.h"
#include "stat.h"

texBlock *fontTex, *gameTex, *pureTex;

int inputType = 0;

void end_game()
{
    closing = 1;
}

void pause()
{
    int temp=inputType;
    if(inputType==0)
      inputType=2;
    if(!closing)
      SuspendThread(logicThread);
    inputType=temp;
}

void input(char key)
{
    if(inputType==1)
    {
        playerInput(key);
        ResumeThread(logicThread);
    }
    else if(inputType==2)
    {
        ResumeThread(logicThread);
    }
    else if(inputType==3)
    {
        if(moveCursor(key))
          ResumeThread(logicThread);
    }
    else if(inputType==4)
    {
        dirKey(key);
        ResumeThread(logicThread);
    }
    else
    {
        switch(key)
        {
          default:
            break;
        }
    }
}

void update()
{
    static int n=0;
    static unsigned char c=0;
    n++;
    n%=24;
    mapBlock_collapse(&mapTex[n%6][n/6]);
    int i;
    for(i=0;i<10;i++)
      addChange(rand()%90,rand()%40);
    updateStat();
}

int spawner_act(creature *this)
{
    this->wait=10000;
    creature_arrive(enemy_rand(40,100,player.level,player.level+2));
    return 1;
}
 
HANDLE miH;
int mi;

DWORD WINAPI startMapInit(LPVOID lpParameter)
{
    mi = 1;
    srand(time(NULL));
    mapInit();
    addChange(player.x,player.y);
    mi = 0;
}

void regenMap()
{
    miH = CreateThread(0,0,startMapInit,0,0,0);
}

void init()
{
    FILE *f = fopen("font.bmp","rb");
    if(!f)
    {
        fprintf(errout,"Fatal error: unable to load font\n");
        closing = 1;
        return;
    }
    pureTex=loadTexture(f);
    if(!pureTex)
    {
        fprintf(errout,"Fatal error: unable to load font\n");
        closing = 1;
        return;
    }
    fontTex = texBlock_clone(pureTex);
    if(!fontTex)
    {
        fprintf(errout,"Fatal error: unable to create text font\n");
        closing = 1;
        return;
    }
    gameTex = texBlock_clone(fontTex);
    if(!gameTex)
    {
        fprintf(errout,"Fatal error: unable to create game font\n");
        closing = 1;
        return;
    }
    player.next=&player;
    player.prev=&player;
    player.speed=1000;
    player.act=player_act;
    player.bump=player_bump;
    player.x=30;
    player.y=20;
    player.c=1;
    player.r=255;
    player.g=255;
    player.b=255;
    player.name = "Player";
    player.moveRate = 10000;
    player.health=5+rand()%5;
    player.damage=1+rand()%5;
    player.damageVar=1+rand()%5;
    player.defense=1+rand()%5;
    player.defenseVar=1+rand()%5;
    player.level=1;
    map[player.x][player.y].occupant=&player;
    int x,y;
    for(x=0;x<3;x++)
      textLine[x] = texBlock_new(720,12);
    stat = texBlock_new(720,24);
    for(x=0;x<6;x++)
    {
        for(y=0;y<4;y++)
        {
            mapTex[x][y].changes = 0;
            mapTex[x][y].image = texBlock_new(120,120);
        }
    }
    creature *aiSpawner = creature_new();
    aiSpawner->act=spawner_act;
    aiSpawner->speed=100;
    miH = CreateThread(0,0,startMapInit,0,0,0);
    //mapInit();
    //Sleep(100);
}

void render()
{
    drawMap();
    drawStat();
    drawText();
    if(inputType==3)
      drawCharDirect(cursorX*8,cursorY*12+24,'X',255,255,0,fontTex);
    //drawTexBlock(gameTex,0,0);
}

void gameLoop()
{
    creature *t = &player;
    while(!closing)
    {
        t->wait -= t->speed;
        if(t->wait<0)
        {
            if(t->act)
              while(t->wait<=0 && !closing)
                t->act(t);
            else
              t->wait = 10000;
        }
        t=t->next;
        if(t==NULL)
        {
            fprintf(errout,"Fatal error: break in creature loop\n");
            closing = 1;
        }
    }
}
