#include <windows.h>
#include "creature.h"
#include "tile.h"
#include "map.h"
#include "win.h"


mapBlock mapTex[6][4];

tile map[90][40];

void addChange(int x, int y)
{
    mapBlock *t = &mapTex[x/15][y/10];
    int i;
    for(i=0;i<t->changes;i++)
      if(t->change[i][0]==x && t->change[i][1]==y)
        return;
    if(t->changes+1>=MAX_CHANGES)
    {
        mapBlock_collapse(t);
    }
    t->change[t->changes][0]=x;
    t->change[t->changes][1]=y;
    t->changes++;
}

void drawMap()
{
    int x,y,i;
    for(x=0;x<6;x++)
    {
        for(y=0;y<4;y++)
        {
            if(mapTex[x][y].image->flags & TEX_FLAG_DIRTY)
              mapBlock_collapse(&mapTex[x][y]);
            drawTexBlock(mapTex[x][y].image,x*120,y*120+24);
            for(i=0;i<mapTex[x][y].changes;i++)
            {
                drawTile(&map[mapTex[x][y].change[i][0]][mapTex[x][y].change[i][1]],mapTex[x][y].change[i][0],mapTex[x][y].change[i][1]);
            }
        }
    }
}

void mapBlock_collapse(mapBlock *block)
{
    int i;
    for(i=0;i<block->changes;i++)
    {
        drawTileToTex(&map[block->change[i][0]][block->change[i][1]],block->change[i][0],block->change[i][1]);
    }
    block->changes=0;
}

void dirtPath(int x, int y, int x2, int y2, int w, int v);
void mapInit()
{
    int x,y;
    for(x=0;x<90;x++)
    {
        for(y=0;y<40;y++)
        {
            while(drawing)
              Sleep(1);
            drawing = 1;
            map[x][y].r=rand()%50;
            map[x][y].g=100+rand()%155;
            map[x][y].b=rand()%50;
            map[x][y].c=rand()%5==2?(rand()&1?'`':'\''):(rand()&1?'.':',');
            if(map[x][y].occupant)
            {
                if(map[x][y].occupant!=&player)
                  creature_remove(map[x][y].occupant);
            }
            else
              map[x][y].occupant=0;
            map[x][y].item=item_rand(1,180,1,2);
            drawTileToTex(&map[x][y],x,y);
            drawing = 0;
        }
        //Sleep(10);
    }
    int n=4;
    while(rand()%n!=0)
    {
        dirtPath(0,rand()%40,90,rand()%40,1,2);
        n--;
    }
}

void dirtStripV(int x, int y, int w, int v)
{
    int ymin=y-w-(rand()%(v+10))/10;
    int ymax=y+w+(rand()%(v+10))/10;
    if(ymin<0)
      ymin=0;
    if(ymax>40)
      ymax=40;
    for(ymin;ymin<ymax;ymin++)
    {
        while(drawing)
          Sleep(1);
        drawing=1;
        int t=50+rand()%100;
        map[x][ymin].r=50+t+rand()%50;
        map[x][ymin].g=t+rand()%25;
        map[x][ymin].b=0;
        map[x][ymin].c='+';//176;//rand()%3==2?',':'.';
        drawTileToTex(&map[x][ymin],x,ymin);
        drawing=0;
    }
}

void dirtPathH(int x, int y, int x2, int y2, int w, int v)
{
    float dy=(float)(y-y2)/(x-x2);
    if(x>x2)
    {
        dy=-dy;
        int t=x;
        x=x2;
        x2=t;
    }
    int i,j=y;
    float ty=y;
    for(i=x;i<x2;i++)
    {
        dirtStripV(i,j,w,v);
        //Sleep(10);
        ty+=dy;
        j=ty;
    }
}

void dirtPath(int x, int y, int x2, int y2, int w, int v)
{
    if(abs(x-x2)>abs(y-y2))
      dirtPathH(x,y,x2,y2,w,v);
    else
      ;//dirtPathH(x,y,x2,y2,w,v);
}
