#include "creature.h"
#include "player.h"
#include "map.h"
#include "text.h"
#include "item.h"
#include "logic.h"
#include "chaos.h"

int cursorX=0, cursorY=0;

void position()
{
    cursorX=player.x;
    cursorY=player.y;
    inputType=3;
    pause();
}

void direction()
{
    inputType=4;
    pause();
}

int action=0;
void player_action()
{
    if(action==1)
      creature_shoot(&player,cursorX,cursorY);
    action=0;
}

int dirAction=0;
int direction_act(int x, int y)
{
    int ret=0;
    if(dirAction==1)
      ret=chaos_bolt(&player,x,y);
    else if(dirAction==2)
      ret=chaos_blast(&player,x,y);
    dirAction=0;
    return ret;
}

void playerInput(char key)
{
    clearText();
    switch(key)
    {
      case '1':
        creature_move(&player,-1,-1);
        break;
      case '2':
        creature_move(&player,0,-1);
        break;
      case '3':
        creature_move(&player,1,-1);
        break;
      case '4':
        creature_move(&player,-1,0);
        break;
      case '5':
        creature_move(&player,0,0);
        break;
      case '6':
        creature_move(&player,1,0);
        break;
      case '7':
        creature_move(&player,-1,1);
        break;
      case '8':
        creature_move(&player,0,1);
        break;
      case '9':
        creature_move(&player,1,1);
        break;
      case ';':
        creature_pickup(&player);
        break;
      case 'f':
        action=1;
        position();
        break;
      case 'q':
        dirAction=1;
        direction();
        break;
      case 'w':
        chaos_flee(&player);
        break;
      case 'e':
        chaos_drain(&player);
        break;
      case 'r':
        chaos_ascension(&player);
        break;
      case 't':
        dirAction=2;
        direction();
        break;
      case 'y':
        chaos_speed(&player);
        break;
      case 'u':
        chaos_heal(&player);
        break;
      case 'i':
        chaos_barrier(&player);
        break;
      case 'o':
        chaos_fury(&player);
        break;
      case 'p':
        chaos_gather(&player);
        break;
      case 'a':
        chaos_death(&player);
        break;
      case 's':
        chaos_confusion(&player);
        break;
#ifdef DEBUG_INPUT
      case 'E':
        randEnemy(rand()%90,rand()%40);
        break;
      case ('M'):
      {
          int i;
          for(i=0;i<100;i++)
            randEnemy(rand()%90,rand()%40);
          break;
      }
      case 'G':
        dropGold((rand()%3)+1,player.x,player.y);
        break;
      case '!':
        corrupt(1);
        break;
      case '@':
        corrupt(10);
        break;
      case '#':
        corrupt(100);
        break;
      case '$':
        corrupt(1000);
        break;
      case '%':
        corrupt(10000);
        break;
      case '^':
        corrupt(100000);
        break;
      case '&':
        uncorrupt(1);
        break;
      case '*':
        uncorrupt(10);
        break;
      case '(':
        uncorrupt(100);
        break;
      case ')':
        uncorrupt(1000);
        break;
#endif
      default:
        break;
    }
}

int player_act(creature *this)
{
    inputType = 1;
    pause();
    inputType = 0;
    if(player.wait>0)
      return 1;
    return 0;
}

void player_bump(creature *this, creature *other)
{
    creature_attack(this,other);
    //addText(other->name);
    //addText("says \'Hey! Watch it!\'");
}

void player_levelup()
{
    player.damage+=rand()%5;
    player.damageVar+=rand()%5;
    player.defense+=rand()%5;
    player.defenseVar+=rand()%5;
    player.health+=rand()%10;
    player.level++;
    addText("You advance a level!");
}

void moveCursorBy(int x, int y)
{
    if(cursorX+x<0 || cursorY+y<0 || cursorX+x>=90 || cursorY+y>=40)
      return;
    cursorX+=x;
    cursorY+=y;
}

int moveCursor(char key)
{
    switch(key)
    {
      case '1':
        moveCursorBy(-1,-1);
        break;
      case '2':
        moveCursorBy(0,-1);
        break;
      case '3':
        moveCursorBy(1,-1);
        break;
      case '4':
        moveCursorBy(-1,0);
        break;
      case '5':
        moveCursorBy(0,0);
        break;
      case '6':
        moveCursorBy(1,0);
        break;
      case '7':
        moveCursorBy(-1,1);
        break;
      case '8':
        moveCursorBy(0,1);
        break;
      case '9':
        moveCursorBy(1,1);
        break;
      default:
        player_action();
        return 1;
    }
    return 0;
}

int dirKey(char key)
{
    switch(key)
    {
      case '1':
        return direction_act(-1,-1);
      case '2':
        return direction_act(0,-1);
      case '3':
        return direction_act(1,-1);
      case '4':
        return direction_act(-1,0);
      case '5':
        return direction_act(0,0);
      case '6':
        return direction_act(1,0);
      case '7':
        return direction_act(-1,1);
      case '8':
        return direction_act(0,1);
      case '9':
        return direction_act(1,1);
      default:
        return 0;
    }
}
