#include "graphics.h"
#include "creature.h"
#include "player.h"
#include "map.h"
#include "stat.h"

texBlock *stat;

char statText[2][90];

void addStatChar(int c, int x, int line)
{
    if(statText[line][x]==c && rand()%100)
      return;
    statText[line][x]=c;
    drawCharToImage(219,0,0,0,x*8,line?0:12,stat,fontTex);
    drawCharToImage(c,255,255,255,x*8,line?0:12,stat,fontTex);
}

int addStatChars(char *str, int x, int line)
{
    int i,len=strlen(str);
    for(i=0;i<len;i++)
      addStatChar(str[i],x+i,line);
    return x+i;
}

void updateStat()
{
    int x=addStatChars("Health: ",0,0);
    x=addStatChars(num(player.health),x,0);

    x=addStatChars(" Magic: ",x,0);
    x=addStatChars(num(player.power),x,0);
    addStatChar(' ',x,0);
    x++;

    x=addStatChars(" Arrows: ",x,0);
    x=addStatChars(num(player.arrows),x,0);
    x=addStatChars("               ",x,0);

    x=addStatChars("Gold: ",0,1);
    x=addStatChars(num(player.gold),x,1);
    addStatChar(' ',x,1);
    x++;

    x=addStatChars(" Level: ",x,1);
    x=addStatChars(num(player.level),x,1);
    addStatChar(' ',x,1);
    x++;

    x=addStatChars(" Damage: ",x,1);
    x=addStatChars(num(player.damage),x,1);
    addStatChar('-',x,1);
    x++;
    x=addStatChars(num(player.damage+player.damageVar),x,1);
    addStatChar(' ',x,1);
    x++;

    x=addStatChars(" Defense: ",x,1);
    x=addStatChars(num(player.defense),x,1);
    addStatChar('-',x,1);
    x++;
    x=addStatChars(num(player.defense+player.defenseVar),x,1);
    addStatChar(' ',x,1);
    x++;
}

void drawStat()
{
    drawTexBlock(stat,0,0);
}
