#include "tile.h"
#include "map.h"
#include "graphics.h"

void tileChanged(int x, int y)
{
    addChange(x,y);
}

void drawTile(tile *src, int x, int y)
{
    drawCharDirect(x*8,y*12+24,219,0,0,0,gameTex);
    if(src->occupant)
      drawCharDirect(x*8,y*12+24,src->occupant->c,src->occupant->r,src->occupant->g,src->occupant->b,gameTex);
    else if(src->item)
      drawCharDirect(x*8,y*12+24,src->item->c,src->item->r,src->item->g,src->item->b,gameTex);
    else
      drawCharDirect(x*8,y*12+24,src->c,src->r,src->g,src->b,gameTex);
}

void drawTileToTex(tile *src, int x, int y)
{
    if(!src || x<0 || y<0 || x>=90 || y>=40)
      return;
    mapBlock *temp = &mapTex[x/15][y/10];
    if(!temp)
      return;
    drawCharToImage(219,0,0,0,(x%15)*8,(y%10)*12,temp->image,gameTex);
    if(src->occupant)
      drawCharToImage(src->occupant->c,src->occupant->r,src->occupant->g,src->occupant->b,(x%15)*8,(y%10)*12,temp->image,gameTex);
    else if(src->item)
      drawCharToImage(src->item->c,src->item->r,src->item->g,src->item->b,(x%15)*8,(y%10)*12,temp->image,gameTex);
    else
      drawCharToImage(src->c,src->r,src->g,src->b,(x%15)*8,(y%10)*12,temp->image,gameTex);
}
